import 'package:bui_component/CardComponent/cardComponent.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/fontSize.dart';
import 'package:flutter/material.dart';

class ButtonView extends StatefulWidget {
  @override
  _ButtonViewState createState() => _ButtonViewState();
}

class _ButtonViewState extends State<ButtonView> {
  List<String> taskName = ["Upcoming Task", "Completed Task"];

  List<TaskBeanDemo> task = [
    TaskBeanDemo(
        taskDate: "4 Dec, 2021",
        taskDescription: "Sharing the business proposal",
        taskName: "Call",
        taskProcess: "Completed Task",
        taskStatus: true,
        taskStatusColor: AppColors.APP_GREEN),
  ];

  List<NotesBeanDemo> notes = [
    NotesBeanDemo(
      notesDate: "4 Dec, 2021",
      notesDesc:
          "Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum. Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.",
    ),
  ];

  bool showFloating = false;
  bool isActiveStatus = false;
  int indexValue;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body: DefaultTabController(
      length: 3,
      child: NestedScrollView(
          headerSliverBuilder: (BuildContext context, bool innerBoxIsScrolled) {
            return <Widget>[
              SliverAppBar(
                expandedHeight: 150.0,
                floating: true,
                pinned: true,
                title: Text("Info"),
                /*Text(widget.accountListBeanData.companyname != null
                      ? widget.accountListBeanData.companyname
                      : widget.pageTitle),*/
                backgroundColor: AppColors.APP_COLOR_PRIMARY,
                bottom: TabBar(
                  onTap: (index) {
                    indexValue = index;
                    if (index == 1) {
                      setState(() {
                        showFloating = true;
                      });
                    } else if (index == 2) {
                      setState(() {
                        showFloating = true;
                      });
                    } else {
                      setState(() {
                        showFloating = false;
                      });
                    }
                  },
                  indicatorColor: AppColors.APP_COLOR_PRIMARY,
                  labelColor: Colors.black87,
                  unselectedLabelColor: Colors.grey,
                  tabs: [
                    Tab(
                      // text: "Account Info",
                      child: Container(
                        child: Text(
                          "Test",
                          style: TextStyle(
                              color: AppColors.APP_COLOR_WHITE,
                              fontSize: 15,
                              fontWeight: FontWeight.bold),
                        ),
                      ),
                    ),
                    Tab(
                      child: Container(
                        child: Text(
                          "Task",
                          style: TextStyle(
                              color: AppColors.APP_COLOR_WHITE,
                              fontSize: 15,
                              fontWeight: FontWeight.bold),
                        ),
                      ),
                    ),
                    Tab(
                      child: Container(
                        child: Text(
                          "NOTES",
                          style: TextStyle(
                              color: AppColors.APP_COLOR_WHITE,
                              fontSize: 15,
                              fontWeight: FontWeight.bold),
                        ),
                      ),
                    ),
                  ],
                ),
              ),
            ];
          },
          body: TabBarView(
            physics: NeverScrollableScrollPhysics(),
            children: [
              _notesView,
              _taskView,
              _notesView,
            ],
          )),
    ));
  }

  Widget get _taskView {
    return ListView.builder(
      itemCount: taskName.length,
      itemBuilder: (_, index) {
        return ExpansionTile(
            title: Text(
              taskName[index].toString(),
              style: TextStyle(
                  color: AppColors.APP_COLOR_BLACK,
                  fontSize: FontSize.FONT_17,
                  fontWeight: FontWeight.bold),
            ),
            children: [
              ...task.map((e) {
                if (e.taskProcess == taskName[index]) {
                  return BUICard.taskCard(
                    cardStatus: e.taskProcess,
                    cardDesc: e.taskDescription,
                    cardDate: e.taskDate,
                    cardType: CardType.cardTask,
                    cardSize: CardSize.medium,
                    cardColor: Colors.white,
                    cardTextColor: Colors.black87,
                    width: MediaQuery.of(context).size.width,
                    padding: 5,
                    height: 120,
                    isActiveStatus: e.taskStatus,
                    shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.circular(15.0),
                    ),
                    elevation: 10,
                    //secondaryColor: AppColors.FACEBOOK_COLOR,
                    onStateChange: () {
                      setState(() {
                        //isActiveStatus = !isActiveStatus;
                        e.taskStatus = !e.taskStatus;
                        if (e.taskProcess == "Completed Task") {
                          e.taskProcess = "Upcoming Task";
                        } else {
                          e.taskProcess = "Completed Task";
                        }
                      });
                    },
                  );
                }
                return Container();
              }).toList(),
            ]);
      },
    );
  }

  Widget get _notesView {
    return ListView.builder(
        padding: const EdgeInsets.all(8),
        itemCount: notes.length,
        itemBuilder: (BuildContext context, int index) {
          return BUICard.notesCard(
            cardType: CardType.cardNotes,
            cardSize: CardSize.medium,
            cardColor: Colors.white,
            cardTextColor: Colors.black87,
            width: MediaQuery.of(context).size.width,
            padding: 2,
            height: 120,
            cardDesc: notes[index].notesDesc,
            cardDate: notes[index].notesDate,
            shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.circular(15.0),
            ),
            elevation: 10,
            secondaryColor: AppColors.REDDISH_GREY,
          );
        });
  }
}

class TaskBeanDemo {
  String taskName;
  bool taskStatus = false;
  String taskDescription;
  String taskProcess;
  String taskDate;
  Color taskStatusColor;

  TaskBeanDemo(
      {this.taskName,
      this.taskStatus,
      this.taskDescription,
      this.taskProcess,
      this.taskDate,
      this.taskStatusColor});
}

class NotesBeanDemo {
  String notesDesc;
  String notesDate;

  NotesBeanDemo({this.notesDesc, this.notesDate});
}
